//---------------------------------------------------------------------------
#ifndef MyUtilsH
#define MyUtilsH
#include <Classes.hpp>
//---------------------------------------------------------------------------
// control utilities
//---------------------------------------------------------------------------
struct TSearchOptions;
extern void __fastcall RedrawMemo(TMemo* AMemo, bool ARedraw);
extern void __fastcall SetMemoText(TMemo* AMemo, AnsiString AText);
extern void __fastcall SetMemoSelText(TMemo* AMemo, AnsiString ASelText);
enum {
	SEARCHMEMO_FIND,
	SEARCHMEMO_REPLACE,
	SEARCHMEMO_REPLACE_ALL,
};
extern bool __fastcall SearchMemo(TMemo* AMemo, const TSearchOptions& AOptions);
//---------------------------------------------------------------------------
// filename utilities
//---------------------------------------------------------------------------
extern AnsiString __fastcall DateTimeToFileName(TDateTime ADateTime);
extern AnsiString __fastcall ShortFileNameToLongFileName(AnsiString AFileName);
//---------------------------------------------------------------------------
// string utilities
//---------------------------------------------------------------------------
extern AnsiString __fastcall FormatInt(AnsiString AValue);
extern int __fastcall lstrcmpn(const char* AStr1, const char* AStr2,
	int ALen);
extern int __fastcall lstrcmpni(const char* AStr1, const char* AStr2,
	int ALen);
extern bool __fastcall IsAlphaNumeric(const char* AStr);
extern bool __fastcall IsWholeWord(const char* AText, const char* APos,
	int ALen);
extern bool __fastcall FindStr(const char* AStr, int ALen,
	const char* AFindStr, int AFindLen, bool AMatchCase, bool AWholeWord,
	bool ADown, int& AIndex);
//---------------------------------------------------------------------------
#endif
