//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TExamItems.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TExamItems : public TObject
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
__fastcall TExamItems::TExamItems(const TExamItems& ASrc)
{
	throw 0;
}
//---------------------------------------------------------------------------
__fastcall TExamItems::operator=(const TExamItems& ASrc)
{
	throw 0;
}
//---------------------------------------------------------------------------
void __fastcall TExamItems::CsvToLines(AnsiString ACsv, TStrings* ALines,
	char ADelimiter, char AQuoteChar)
{
	const char* src = ACsv.c_str();
	int dstLen = ACsv.Length() + 5;
	char* dstStr = new char[dstLen];
	char* dst;
	bool quoted;
	AnsiString line;

	ALines->Clear();
	for(;;) {
		while(isspace(*src) && *src != AQuoteChar && *src != ADelimiter &&
			*src != '\0') {
			src = CharNext(src);
		}
		quoted = *src == AQuoteChar;
		if(quoted) {
			src = CharNext(src);
		}
		dst = dstStr;
		FillMemory(dstStr, dstLen, '\0');
		for(;;) {
			if(*src == '\0') {
				*dst = '\0';
				break;
			}
			if(quoted) {
				if(*src == AQuoteChar) {
					if(*(src + 1) == AQuoteChar) {
						src++;
					}
					else {
						*dst = '\0';
						break;
					}
				}
			}
			else {
				if(*src == ADelimiter) {
					*dst = '\0';
					break;
				}
			}
			*dst = *src;
			if(IsDBCSLeadByte(*src)) {
				*(dst + 1) = *(src + 1);
			}
			src = CharNext(src);
			dst = CharNext(dst);
		}
		line = AnsiString(dstStr);
		if(!quoted) {
			line = line.Trim();
		}
		ALines->Add(line);
		while(*src != ADelimiter && *src != '\0') {
			src = CharNext(src);
		}
		if(*src == '\0') {
			break;
		}
		src = CharNext(src);
	}

	delete [] dstStr;
}
//---------------------------------------------------------------------------
int __fastcall TExamItems::CountAnswers(const TStrings* ALines, int AIndex)
{
	int count = 0;
	TStrings* lines = const_cast<TStrings*>(ALines);

	for(int i = AIndex; i < lines->Count; i++) {
		if(*lines->Strings[i].c_str() != '\t') {
			break;
		}
		count++;
	}
	if(count <= 0) {
		count = 1;
	}

	return count;
}
//---------------------------------------------------------------------------
void __fastcall TExamItems::LoadFromFile_ParseCsv(TExamItems* AItems,
	TStrings* ALines) const
{
	TExamItem* item;
	TStringList* lines = new TStringList();

	for(int i = 0; i < ALines->Count; i++) {
		CsvToLines(ALines->Strings[i], lines, CSV_DELIMITER, CSV_QUOTE_CHAR);
		item = AItems->Add();
		for(int j = 0; j < lines->Count; j++) {
			if(j == 0) {
				item->Question = lines->Strings[j].Trim();
			}
			else {
				item->AddAnswer(lines->Strings[j].Trim());
			}
		}
	}

	delete lines;
}
//---------------------------------------------------------------------------
void __fastcall TExamItems::LoadFromFile_ParseText(TExamItems* AItems,
	TStrings* ALines) const
{
	TExamItem* item;
	int index = 0;
	int answerCount;

	while(index < ALines->Count) {
		if(index < ALines->Count) {
			item = AItems->Add();
			item->Question = ALines->Strings[index++].Trim();
		}
		if(index < ALines->Count) {
			answerCount = CountAnswers(ALines, index);
			for(int i = 0; i < answerCount; i++) {
				item->AddAnswer(ALines->Strings[index++].Trim());
			}
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TExamItems::LoadFromFile_Pack(TExamItems* AItems)
{
	TExamItem* item;

	for(int i = 0; i < AItems->Count; i++) {
		item = AItems->Items[i];
		for(int j = 0; j < item->AnswerCount; j++) {
			if(item->Answers[j].IsEmpty()) {
				item->DeleteAnswer(j--);
			}
		}
		if(item->Question.IsEmpty() || item->AnswerCount <= 0) {
			AItems->Delete(i--);
		}
	}
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
int __fastcall TExamItems::GetCount() const
{
	return FList->Count;
}
//---------------------------------------------------------------------------
TExamItem* __fastcall TExamItems::GetItem(int AIndex) const
{
	return static_cast<TExamItem*>(FList->Items[AIndex]);
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TExamItems::TExamItems() :
	TObject(),
	FList(new TList())
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TExamItems::~TExamItems()
{
	Clear();

	delete FList; FList = NULL;
}
//---------------------------------------------------------------------------
bool __fastcall TExamItems::LoadFromFile(AnsiString AFile, int AFileType)
{
	bool succeeded = false;
	TStringList* lines = new TStringList();
	TExamItems* items = new TExamItems();

	try {
		lines->LoadFromFile(AFile);
		switch(AFileType) {
			case FILETYPE_CSV:
				LoadFromFile_ParseCsv(items, lines);
				break;
			case FILETYPE_TEXT:
				LoadFromFile_ParseText(items, lines);
				break;
			default:
				// do nothing
				break;
		}
		LoadFromFile_Pack(items);
		if(items->Count > 0) {
			Assign(items);
			succeeded = true;
		}
	}
	__finally {
		delete items;
		delete lines;

		return succeeded;
	}
}
//---------------------------------------------------------------------------
TExamItem* __fastcall TExamItems::Add()
{
	TExamItem* item = new TExamItem();

	FList->Add(item);

	return item;
}
//---------------------------------------------------------------------------
void __fastcall TExamItems::MoveTo(int AIndex, TExamItems* ADst)
{
	ADst->Add()->Assign(Items[AIndex]);
	Delete(AIndex);
}
//---------------------------------------------------------------------------
void __fastcall TExamItems::Delete(int AIndex)
{
	delete static_cast<TExamItem*>(FList->Items[AIndex]);
	FList->Delete(AIndex);
}
//---------------------------------------------------------------------------
void __fastcall TExamItems::Clear()
{
	for(int i = 0; i < Count; i++) {
		delete static_cast<TExamItem*>(FList->Items[i]);
	}
	FList->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TExamItems::Assign(const TExamItems* ASrc)
{
	if(ASrc == this) {
		return;
	}

	Clear();
	for(int i = 0; i < ASrc->Count; i++) {
		Add()->Assign(ASrc->Items[i]);
	}
}
//---------------------------------------------------------------------------

