//---------------------------------------------------------------------------
#ifndef TExamItemsH
#define TExamItemsH
#include <Classes.hpp>
#include "TExamItem.h"
//---------------------------------------------------------------------------
class TExamItems : public TObject
{
public:
	enum {
		FILETYPE_CSV,
		FILETYPE_TEXT,
	};
	static const char CSV_DELIMITER = ',';
	static const char CSV_QUOTE_CHAR = '\"';
private:
	TList* FList;
	__fastcall TExamItems(const TExamItems& ASrc);
	__fastcall operator=(const TExamItems& ASrc);
	static void __fastcall CsvToLines(AnsiString ACsv, TStrings* ALines,
		char ADelimiter, char AQuoteChar);
	static int __fastcall CountAnswers(const TStrings* ALines, int AIndex);
	void __fastcall LoadFromFile_ParseCsv(TExamItems* AItems,
		TStrings* ALines) const;
	void __fastcall LoadFromFile_ParseText(TExamItems* AItems,
		TStrings* ALines) const;
	void __fastcall LoadFromFile_Pack(TExamItems* AItems);
protected:
	int __fastcall GetCount() const;
	TExamItem* __fastcall GetItem(int AIndex) const;
public:
	__fastcall TExamItems();
	__fastcall ~TExamItems();
	bool __fastcall LoadFromFile(AnsiString AFile, int AFileType);
	TExamItem* __fastcall Add();
	void __fastcall Delete(int AIndex);
	void __fastcall MoveTo(int AIndex, TExamItems* ADst);
	void __fastcall Clear();
	void __fastcall Assign(const TExamItems* ASrc);
	__property int Count = {read=GetCount};
	__property TExamItem* Items[int AIndex] = {read=GetItem};
};
//---------------------------------------------------------------------------
#endif
