//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>
#include "TSearchOptions.h"
#include "TViewOptions.h"
#include "TExamOptions.h"
//---------------------------------------------------------------------------
class THistory;
class TExam;
class TExamItems;
class TOpenDialogs;
class TMainForm : public TForm
{
__published:
	TMainMenu *MainMenu1;
	TMenuItem *FileM1;
	TMenuItem *NewM1;
	TMenuItem *OpenM1;
	TMenuItem *SaveLogM1;
	TMenuItem *StartM1;
	TMenuItem *ReviewM1;
	TMenuItem *ListM1;
	TMenuItem *History1;
	TMenuItem *File1M1;
	TMenuItem *File2M1;
	TMenuItem *File3M1;
	TMenuItem *File4M1;
	TMenuItem *File5M1;
	TMenuItem *ClearM1;
	TMenuItem *ExitM1;
	TMenuItem *EditM1;
	TMenuItem *FindM1;
	TMenuItem *FindNextM1;
	TMenuItem *FindPrevM1;
	TMenuItem *SelectAllM1;
	TMenuItem *ViewM1;
	TMenuItem *ToolbarM1;
	TMenuItem *ToolbarCaptionsM1;
	TMenuItem *FontM1;
	TMenuItem *TabWidthM1;
	TMenuItem *SwapPanelsM1;
	TMenuItem *StatusBarM1;
	TMenuItem *LastPositionM1;
	TMenuItem *TopmostM1;
	TMenuItem *DefaultM1;
	TMenuItem *OptionsM1;
	TMenuItem *ShuffleM1;
	TMenuItem *SwapM1;
	TMenuItem *CaseSensitiveM1;
	TMenuItem *DefaultM2;
	TMenuItem *HelpM1;
	TMenuItem *HelpM2;
	TMenuItem *AboutM1;
	TMenuItem *MenuItem1;
	TMenuItem *MenuItem2;
	TMenuItem *MenuItem3;
	TMenuItem *MenuItem4;
	TMenuItem *MenuItem5;
	TMenuItem *MenuItem6;
	TMenuItem *MenuItem7;
	TMenuItem *MenuItem8;
	TMenuItem *MenuItem9;
	TToolBar *ToolBar1;
	TToolButton *NewT1;
	TToolButton *OpenT1;
	TToolButton *LogT1;
	TToolButton *StartT1;
	TToolButton *ReviewT1;
	TToolButton *ListT1;
	TToolButton *ShuffleT1;
	TToolButton *SwapT1;
	TToolButton *CaseT1;
	TToolButton *ToolButton1;
	TToolButton *ToolButton2;
	TImageList *ImageList1;
	TPanel *Panel1;
	TPanel *Panel2;
	TPanel *Panel3;
	TLabel *Label1;
	TLabel *Label2;
	TEdit *Edit1;
	TEdit *Edit2;
	TMemo *Memo1;
	TStatusBar *StatusBar1;
	TOpenDialog *OpenDialog1;
	TSaveDialog *SaveDialog1;
	TFontDialog *FontDialog1;
	void __fastcall ApplicationIdle(TObject* ASender, bool& ADone);
	void __fastcall FormShow(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall NewM1Click(TObject* ASender);
	void __fastcall OpenM1Click(TObject* ASender);
	void __fastcall SaveLogM1Click(TObject* ASender);
	void __fastcall StartM1Click(TObject* ASender);
	void __fastcall ListM1Click(TObject* ASender);
	void __fastcall HistoryM1Click(TObject* ASender);
	void __fastcall ClearM1Click(TObject* ASender);
	void __fastcall ExitM1Click(TObject* ASender);
	void __fastcall FindM1Click(TObject* ASender);
	void __fastcall SelectAllM1Click(TObject* ASender);
	void __fastcall ViewM1Click(TObject* ASender);
	void __fastcall OptionsM1Click(TObject* ASender);
	void __fastcall HelpM2Click(TObject* ASender);
	void __fastcall AboutM1Click(TObject* ASender);
	void __fastcall ToolButtonClick(TObject* ASender);
	void __fastcall Edit2KeyDown(TObject* ASender, WORD& AKey,
		TShiftState AShift);
	void __fastcall Memo1Change(TObject* ASender);
private:
	enum {
		SELECTFILES_OPEN_FILE,
		SELECTFILES_SAVE_LOG,
	};
	AnsiString FFileName;
	THistory* FHistory;
	TExam* FExam;
	TSearchOptions FSearchOptions;
	TViewOptions FViewOptions;
	TExamOptions FExamOptions;
	TOpenDialogs* FOpenDialogs;
	static void __fastcall FlipBool(bool& AValue);
	static void __fastcall EnsureParagraph(TStrings* ALines);
	static AnsiString __fastcall ItemsToText(const TExamItems* AItems);
	static void __fastcall TellError(AnsiString AMessage);
	static int __fastcall AskOkCancel(AnsiString AMessage);
	void __fastcall TellCantOpen(AnsiString AFile) const;
	void __fastcall TellCantSave(AnsiString AFile) const;
	bool __fastcall AskClose() const;
	bool __fastcall TellNoLog() const;
	bool __fastcall TellNoItem(bool AReview) const;
	bool __fastcall AskQuitExam() const;
	bool __fastcall AskFileType(AnsiString AFile, int& AFileType) const;
	bool __fastcall SelectFiles(int AOperation, AnsiString& AFileName,
		TStrings* AFiles) const;
	bool __fastcall SelectFont(TViewOptions& AViewOptions) const;
	bool __fastcall EnterTabWidth(TViewOptions& AViewOptions) const;
	void __fastcall NewFile();
	void __fastcall OpenFile(AnsiString AFile);
	bool __fastcall OpenFile_GetFileType(AnsiString AFile, int& AFileType);
	void __fastcall StartExam(bool AReview);
	void __fastcall ProceedExam();
	void __fastcall ScoreExam();
	void __fastcall ScoreExam_Prepare(AnsiString& AQuestion,
		TStringList* AAnswers, AnsiString& AEntry) const;
	void __fastcall ScoreExam_Score(AnsiString& AQuestion,
		TStringList* AAnswers, AnsiString& AEntry);
	void __fastcall StopExam();
	void __fastcall EndExam();
	void __fastcall ProcessCommandParams();
	void __fastcall LoadSettings();
	void __fastcall SaveSettings();
protected:
	void __fastcall SetFileName(AnsiString AFileName);
	void __fastcall FileNameChange();
	AnsiString __fastcall GetItemList() const;
	void __fastcall SetSearchOptions(TSearchOptions ASearchOptions);
	void __fastcall SearchOptionsChange();
	void __fastcall SetViewOptions(TViewOptions AViewOptions);
	void __fastcall ViewOptionsChange();
	void __fastcall SetExamOptions(TExamOptions AExamOptions);
	void __fastcall ExamOptionsChange();
	void __fastcall HistoryChange();
	void __fastcall ExamChange();
	void __fastcall FilesDrop(const TStrings* AFiles);
	void __fastcall WMDropFiles(TWMDropFiles& AMessage);
public:
	__fastcall TMainForm(TComponent* AOwner);
	__fastcall ~TMainForm();
	bool __fastcall IsPlaying() const;
	void __fastcall ShowStatus(AnsiString AStatus);
	__property AnsiString FileName = {read=FFileName, write=SetFileName};
	__property THistory* History = {read=FHistory};
	__property TExam* Exam = {read=FExam};
	__property AnsiString ItemList = {read=GetItemList};
	__property TSearchOptions SearchOptions = {read=FSearchOptions,
		write=SetSearchOptions};
	__property TViewOptions ViewOptions = {read=FViewOptions,
		write=SetViewOptions};
	__property TExamOptions ExamOptions = {read=FExamOptions,
		write=SetExamOptions};
	__property TOpenDialogs* OpenDialogs = {read=FOpenDialogs};
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm* MainForm;
//---------------------------------------------------------------------------
#endif
