//----------------------------------------------------------------------------
#ifndef TSearchDialogH
#define TSearchDialogH
//----------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include "TSearchOptions.h"
//----------------------------------------------------------------------------
class TSearchDialog : public TForm
{
__published:
	TLabel *Label1;
	TLabel *Label2;
	TEdit *Edit1;
	TEdit *Edit2;
	TCheckBox *CheckBox1;
	TCheckBox *CheckBox2;
	TRadioGroup *RadioGroup1;
	TButton *Button1;
	TButton *Button2;
	TButton *Button3;
	TButton *Button4;
	void __fastcall FormShow(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
private:
	TSearchOptions FOptions;
	struct {
		TSearchOptions Options;
	} FBackup;
	static int __fastcall ModalResultToOperation(TModalResult AModalResult);
	void __fastcall TellError(TWinControl* AErrorControl = NULL);
	void __fastcall ResetParams();
	void __fastcall BackupParams(AnsiString AFindText);
	void __fastcall RestoreParams();
	bool __fastcall UpdateParams();
protected:
	void __fastcall SetOptions(TSearchOptions AOptions);
public:
	virtual __fastcall TSearchDialog(TComponent* AOwner);
	virtual __fastcall ~TSearchDialog();
	bool __fastcall Execute(AnsiString AFindText, bool AFind);
	__property TSearchOptions Options = {read=FOptions, write=SetOptions};
};
//----------------------------------------------------------------------------
extern PACKAGE TSearchDialog* SearchDialog;
//----------------------------------------------------------------------------
#endif    
