//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TStrFindDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TStrFindDialog* StrFindDialog = NULL;
//---------------------------------------------------------------------------
// class TStrFindDialog : public TForm
//---------------------------------------------------------------------------
// __published:
//---------------------------------------------------------------------------
void __fastcall TStrFindDialog::FormShow(TObject* ASender)
{
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TStrFindDialog::FormCloseQuery(TObject* ASender,
	bool& ACanClose)
{
	ACanClose = true;
	switch(ModalResult) {
		case mrOk:
			if(!UpdateParams()) {
				ACanClose = false;
			}
			break;
		default:
			RestoreParams();
			break;
	}
}
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
void __fastcall TStrFindDialog::TellError(TWinControl* AErrorControl)
{
	AnsiString errorMessage;

	ActiveControl = AErrorControl;
	if(AErrorControl == Edit1) {
		errorMessage = "Set the text to find.";
	}
	else {
		errorMessage = "Set the proper value.";
	}
	Application->MessageBox(
		errorMessage.c_str(),
		Application->Title.c_str(),
		MB_ICONERROR | MB_SETFOREGROUND);
}
//---------------------------------------------------------------------------
void __fastcall TStrFindDialog::ResetParams()
{
	Options = TSearchOptions();
}
//---------------------------------------------------------------------------
void __fastcall TStrFindDialog::BackupParams(AnsiString AFindText)
{
	FBackup.Options = Options;
	if(!AFindText.IsEmpty()) {
		TSearchOptions options = Options;

		options.FindText = AFindText;
		Options = options;
	}
}
//---------------------------------------------------------------------------
void __fastcall TStrFindDialog::RestoreParams()
{
	Options = FBackup.Options;
}
//---------------------------------------------------------------------------
bool __fastcall TStrFindDialog::UpdateParams()
{
	try {
		TSearchOptions options;

		options.Operation = TSearchOptions::OPERATION_FIND;
		options.FindText = Edit1->Text;
		if(options.FindText.IsEmpty()) {
			TellError(Edit1);
			return false;
		}
		options.ReplaceText = "";
		options.MatchCase = CheckBox1->Checked;
		options.WholeWord = CheckBox2->Checked;
		options.Down = RadioGroup1->ItemIndex == 1;
		Options = options;
	}
	catch(...) {
		TellError(NULL);
		return false;
	}

	return true;
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
void __fastcall TStrFindDialog::SetOptions(TSearchOptions AOptions)
{
	FOptions = AOptions;
	Edit1->Text = FOptions.FindText;
	CheckBox1->Checked = FOptions.MatchCase;
	CheckBox2->Checked = FOptions.WholeWord;
	RadioGroup1->ItemIndex = FOptions.Down ? 1 : 0;
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TStrFindDialog::TStrFindDialog(TComponent* AOwner) :
	TForm(AOwner),
	FOptions()
{
	ResetParams();
}
//---------------------------------------------------------------------------
__fastcall TStrFindDialog::~TStrFindDialog()
{
	// do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TStrFindDialog::Execute(AnsiString AFindText)
{
	BackupParams(AFindText);

	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

