//----------------------------------------------------------------------------
#ifndef TStrFindDialogH
#define TStrFindDialogH
//----------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include "TSearchOptions.h"
//----------------------------------------------------------------------------
class TStrFindDialog : public TForm
{
__published:
	TLabel *Label1;
	TEdit *Edit1;
	TCheckBox *CheckBox1;
	TCheckBox *CheckBox2;
	TRadioGroup *RadioGroup1;
	TButton *Button1;
	TButton *Button2;
	void __fastcall FormShow(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
private:
	TSearchOptions FOptions;
	struct {
		TSearchOptions Options;
	} FBackup;
	void __fastcall TellError(TWinControl* AErrorControl = NULL);
	void __fastcall ResetParams();
	void __fastcall BackupParams(AnsiString AFindText);
	void __fastcall RestoreParams();
	bool __fastcall UpdateParams();
protected:
	void __fastcall SetOptions(TSearchOptions AOptions);
public:
	virtual __fastcall TStrFindDialog(TComponent* AOwner);
	virtual __fastcall ~TStrFindDialog();
	bool __fastcall Execute(AnsiString AFindText);
	__property TSearchOptions Options = {read=FOptions, write=SetOptions};
};
//----------------------------------------------------------------------------
extern PACKAGE TStrFindDialog* StrFindDialog;
//----------------------------------------------------------------------------
#endif
