//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TViewOptions.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace
{
const TFontStyle FontStyleTable[] = {
	fsBold,
	fsItalic,
	fsUnderline,
	fsStrikeOut,
};
const int FontStyleSize = sizeof(FontStyleTable) / sizeof(TFontStyle);
} // end of namespace
//---------------------------------------------------------------------------
// struct TViewOptions
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
int __fastcall TViewOptions::GetFontStyleAsInt() const
{
	int value = 0;

	for(int i = 0; i < FontStyleSize; i++) {
		if(FontStyle.Contains(FontStyleTable[i])) {
			value |= 1 << i;
		}
	}

	return value;
}
//---------------------------------------------------------------------------
void __fastcall TViewOptions::SetFontStyleAsInt(int AInt)
{
	TFontStyles style;
	int mask;

	for(int i = 0; i < FontStyleSize; i++) {
		mask = 1 << i;
		if((AInt & mask) == mask) {
			style << FontStyleTable[i];
		}
	}
	FontStyle = style;
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TViewOptions::TViewOptions() :
	ToolBar(true),
	ToolBarCaptions(false),
	FontName("Default"),
	FontSize(9),
	FontStyle(),
	TabWidth(8),
	SwapPanels(false),
	StatusBar(true),
	LastPosition(false),
	Topmost(false)
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TViewOptions::TViewOptions(const TViewOptions& ASrc) :
	ToolBar(true),
	ToolBarCaptions(false),
	FontName("Default"),
	FontSize(9),
	FontStyle(),
	TabWidth(8),
	SwapPanels(false),
	StatusBar(true),
	LastPosition(false),
	Topmost(false)
{
	*this = ASrc;
}
//---------------------------------------------------------------------------
__fastcall TViewOptions::~TViewOptions()
{
	// do nothing
}
//---------------------------------------------------------------------------
TViewOptions& __fastcall TViewOptions::operator=(const TViewOptions& ASrc)
{
	if(&ASrc != this) {
		ToolBar = ASrc.ToolBar;
		ToolBarCaptions = ASrc.ToolBarCaptions;
		FontName = ASrc.FontName;
		FontSize = ASrc.FontSize;
		FontStyle = ASrc.FontStyle;
		TabWidth = ASrc.TabWidth;
		SwapPanels = ASrc.SwapPanels;
		StatusBar = ASrc.StatusBar;
		LastPosition = ASrc.LastPosition;
		Topmost = ASrc.Topmost;
	}

	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TViewOptions::operator==(const TViewOptions& ASrc) const
{
	return
		ToolBar == ASrc.ToolBar &&
		ToolBarCaptions == ASrc.ToolBarCaptions &&
		FontName == ASrc.FontName &&
		FontSize == ASrc.FontSize &&
		FontStyle == ASrc.FontStyle &&
		TabWidth == ASrc.TabWidth &&
		SwapPanels == ASrc.SwapPanels &&
		StatusBar == ASrc.StatusBar &&
		LastPosition == ASrc.LastPosition &&
		Topmost == ASrc.Topmost;
}
//---------------------------------------------------------------------------
bool __fastcall TViewOptions::operator!=(const TViewOptions& ASrc) const
{
	return !(*this == ASrc);
}
//---------------------------------------------------------------------------

